using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Security;

namespace Decal.Interop.Core;

[ComImport]
[TypeLibType(2)]
[SuppressUnmanagedCodeSecurity]
[ClassInterface(0)]
[Guid("7559F22F-C56F-4621-AE08-9C354D799D4B")]
public class ActiveXSurrogateClass : IDecalFileSurrogate, ActiveXSurrogate, IDecalUninstall
{
	[DispId(1610678273)]
	public virtual extern string Extension
	{
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
		[return: MarshalAs(UnmanagedType.BStr)]
		get;
	}

	[DispId(1610678274)]
	public virtual extern string Description
	{
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
		[return: MarshalAs(UnmanagedType.BStr)]
		get;
	}

	[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
	public virtual extern void Register([MarshalAs(UnmanagedType.BStr)] string Filename);

	[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
	public virtual extern void Prepare([MarshalAs(UnmanagedType.Interface)] DecalEnum pEnum);

	[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
	public virtual extern void Uninstall();
}
